#!/usr/bin/python
# coding=UTF-8

# Багрепорты и фичареквесты можно слать сюда: nagato@shell.tor.hu

import urllib
import json
import sys
import time
import re
import pynotify
import gtk.gdk
import optparse

timeout = 30 # период проверки обновлений
#hideSage = True # sage disabled on dobrochan
hideWithoutText = False
hideWithoutPic = False
htmlFormat = True # html works on KDE only?
showTime = 5000 # время отображения уведомления
postColor = '#65B2FF'
quoteColor = '#FFF11F'
spoilerColor = '#C8C8C8'
codeColor = '#E26AFF'
sad = True # sad, but true

def wakabamarkToHtml(text,title):
  # TODO: ^W, ^H
  regList = [
    (r"&", r"&amp;"),
    (r"#", r"&#35;"),
    (r"\"", r"&quot;"),
    (r"%", r"&#37;"),
    (r"'", r"&#39;"),
    (r"\\", r"&#92;"),
    (r"/", r"&#47;"),
    (r"\+", r"&#43;"),
    (r"=", r"&#61;"),
    (r"<", r"&#60;"),
    (r">", r"&#62;")
    ]
  for rule in regList:
    text = re.sub(rule[0],rule[1],text)
  textList = text.split("\r\n")
  regList = [
    (r"_(_|\*)\*(.+?)\*\1_",r"<b><i>\2</b></i>"),                                           # bold+italic
    (r"(\*\*|__)(.+?)\1",r"<b>\2</b>"),                                                     # bold
    (r"([\*_])(.+?)\1",r"<i>\2</i>"),                                                       # italic
    (r"`(.+?)`",r"<font color='%s'>\1</font>"%codeColor),                                   # mono
    (r"&#37;&#37;(.+?)&#37;&#37;",r"<font color='%s'>\1</font>"%spoilerColor),              # spoiler
    (r"(&#62;&#62;((&#47;)?[a-z]+&#47;)?\d+)",r"<font color='%s'>\1</font>"%postColor)      # post
#   (r"(\b\w+?\b)(\^H)*\^W(\^[WH])*",r"<s>\1</s>")	# ^W
    ]
  text = ""
  for textLine in textList:
    for rule in regList:
      if not textLine.startswith("    "):
        textLine = re.sub(rule[0],rule[1],textLine)
    if len(text):
      text += "\r\n"
    text += textLine
  multiLineRegList = [
    (r"(^|\r\n)&#37;&#37;\r\n(.*((\r\n.*)*))\r\n&#37;&#37;($|\r\n)",r"\1<font color='%s'>\2</font>\5"%spoilerColor),  # spoiler
    (r"(^|\r\n)``\r\n(.*(\r\n.*)*)\r\n``($|\r\n)",r"\1<font color='%s'>\2</font>\4"%codeColor),                       # mono
    (r"(^|\r\n)(&#62;.+?)(\r\n|$)",r"\1<font color='%s'>\2</font>\3"%quoteColor),                                     # quote
    (r"(\r\n){2,}",r"\r\n")
    ]
  for rule in multiLineRegList:
    text = re.sub(rule[0],rule[1],text,re.DOTALL|re.MULTILINE)
  text = u"Новое сообщение %s:<br/>%s"%(post['date'],text)
  title = "<a href=\"http://%s/%s/res/%s.xhtml\">%s</a>"%(host,board,thread,title)
  return text, title

# START

parser = optparse.OptionParser()
parser.add_option('-b','--board',action="store",dest="board",help="Board of thread", default="lor")
parser.add_option('-t','--thread',action="store",dest="thread",help="Thread display ID", default="16218")
parser.add_option('-i','--lastid',action="store",dest="lastId",help="Last message display ID", default="-1")
parser.add_option('-s','--site',action="store",dest="host",help="Site adress (default - dobrochan.ru)", default="dobrochan.ru")
options, args = parser.parse_args()

host = options.host
board = options.board
thread = options.thread

if not pynotify.init("%s notificator"%host):
    print u"Ошибка при инициализации модуля pynotify. Может быть он не установлен?"
    exit()

try:
  urllib.urlretrieve('http://%s/favicon.ico'%host,'/tmp/%s.ico'%host)
except:
  print u"Ошибка при получении favicon"

err = 1
while err:
  try:
    info = urllib.urlopen("http://%s/api/thread/info/%s/%s.json"%(host,board,thread))
    messages = urllib.urlopen("http://%s/%s/res/%s.json"%(host,board,thread))
    infoDump = info.read()
    messDump = messages.read()
    infoObj = json.loads(infoDump)
    messObj = json.loads(messDump)
    err = 0
  except:
    print u"Не могу получить данные... Повтор"
    time.sleep(timeout)
    err = 1
print u"В треде >>%s/%s \"%s\" найдено: сообщений - %s, файлов - %s. Последнее изменение произведено в %s"%(
  board,
  thread,
  infoObj['boards'][board]['threads'][0]['title'],
  infoObj['boards'][board]['threads'][0]['posts_count'],
  infoObj['boards'][board]['threads'][0]['files_count'],
  infoObj['boards'][board]['threads'][0]['last_modified']
)
if "-1" == options.lastId:
  lastId = messObj['boards'][board]['threads'][0]['posts'].pop()['display_id']
else:
  lastId = options.lastId
posts = []
while 1:
  try:
    messages = urllib.urlopen("http://%s/api/thread/new/%s/%s.json?last_post=%s"%(host,board,thread,lastId))
    messDump = messages.read()
    messObj = json.loads(messDump)
  except:
    print u"Ошибка подключения.. Повтор"
    time.sleep(timeout)
    continue
  if 'posts' in messObj['boards'][board]['threads'][0]:
    posts = messObj['boards'][board]['threads'][0]['posts']
  else:
    posts = []
  for post in posts:
    lastId = post['display_id']
#    if (hideSage and post['sage']) or (hideWithoutText and 0==len(post['message'])):
    if hideWithoutText and 0==len(post['message']):
      continue
    print "%s : %s"%(post['display_id'],post['message'])
    mesFile = post['files']
    mesThumbData = 0
    if mesFile and ('thumb' in mesFile[0].keys()):
      try:
        mesThumb = urllib.urlopen("http://%s/%s"%(host,mesFile[0]['thumb']))
        mesThumbData = mesThumb.read()
      except:
        mesThumbData = 0
    if hideWithoutPic and (0 == mesThumbData):
        continue
    messageText = post['message']
    if htmlFormat:
      messageText, messageTitle = wakabamarkToHtml(messageText,infoObj['boards'][board]['threads'][0]['title'])
      print "Formated: "+messageText
    else:
      messageText = u"Новое сообщение %s:\n%s"%(post['date'],messageText)
      messageTitle = infoObj['boards'][board]['threads'][0]['title']
    filesCount = len(post['files'])
    if filesCount > 1:
      messageText += '\n(%s файла)'%filesCount;
    n = pynotify.Notification(
      messageTitle,
      messageText,
      '/tmp/%s.ico'%host)
    n.set_urgency(pynotify.URGENCY_NORMAL)
    if mesThumbData:
      loader = gtk.gdk.PixbufLoader()
      loader.write(mesThumbData)
      loader.close()
      pixbuf = loader.get_pixbuf()
      n.set_icon_from_pixbuf(pixbuf)
    n.set_timeout(showTime)
    n.show()
  time.sleep(timeout)